# rsyslog configuration file
## 10-22 debug mode
$DebugFile /var/log/rsyslog.debug
$DebugLevel 0

# For more information see /usr/share/doc/rsyslog-*/rsyslog_conf.html
# If you experience problems, see http://www.rsyslog.com/doc/troubleshoot.html

$MaxMessageSize 64K

#### MODULES ####
###
# The imjournal module bellow is now used as a message source instead of imuxsock.
$ModLoad imuxsock # provides support for local system logging (e.g. via logger command)
$ModLoad imjournal # provides access to the systemd journal
#$ModLoad imklog # reads kernel messages (the same are read from journald)
#$ModLoad immark  # provides --MARK-- message capability

module(
load="imudp"
)

input(
type="imudp"  
port="514"
)


module(
load="imptcp"
)

input(
type="imptcp"  
port="601"
##port="20514"
)


#### 10/15/2020 Changes for TLS - DefaultNetstreamDriver

module(load="imtcp" # TCP listener
    StreamDriver.Name="gtls"
    StreamDriver.Mode="1" # run driver in TLS-only mode
    StreamDriver.Authmode="anon"
    )

# make gtls driver the default and set certificate files
## make PEM Files the same on all VMs - tpg-machinecert.pem, tpg-machinekey.pem
global(
    DefaultNetstreamDriver="gtls"
    DefaultNetstreamDriverCAFile="/etc/rsyslog.d/tpg-issuing-ca.pem"
    DefaultNetstreamDriverCertFile="/etc/rsyslog.d/tpg-machinecert.pem"
    DefaultNetstreamDriverKeyFile="/etc/rsyslog.d/tpg-machinekey.pem"
    )

    # start up listener at port 6514
    input(
    type="imtcp"
    port="6514"
    )
	
# Provides UDP syslog reception
## convert to modern syntax
##$ModLoad imudp
##$UDPServerRun 514

# Provides TCP syslog reception - assume it can run on 2 ports concurrently
# imtpc defined above
##$ModLoad imtcp
##$InputTCPServerRun 6514

## convert to modern syntax
##$ModLoad imptcp
##$InputPTCPServerRun 20514  

##$ActionSendStreamDriverAuthMode x509/name
##$ActionSendStreamDriverPermittedPeer *.texpac.com
##$ActionSendStreamDriverMode 0 # run driver in TLS-only mode

## $InputTCPServerRun 514
#### End changes - 10/15/2020 
####################################################################

#### GLOBAL DIRECTIVES ####

# Where to place auxiliary files
$WorkDirectory /var/lib/rsyslog

# Use default timestamp format
$ActionFileDefaultTemplate RSYSLOG_TraditionalFileFormat

# File syncing capability is disabled by default. This feature is usually not required,
# not useful and an extreme performance hit
#$ActionFileEnableSync on

# Include all config files in /etc/rsyslog.d/
$IncludeConfig /etc/rsyslog.d/*.conf

# Turn off message reception via local log socket;
# local messages are retrieved through imjournal now.
$OmitLocalLogging on

# File to store the position in the journal
$IMJournalStateFile imjournal.state



# Increase the amount of open files rsyslog is allowed, which includes open tcp sockets
# This is important if there are many clients.
# http://www.rsyslog.com/doc/rsconf1_maxopenfiles.html
$MaxOpenFiles 2048



#### RULES ####

# Log all kernel messages to the console.
# Logging much else clutters up the screen.
#kern.*                                                 /dev/console

# Log anything (except mail) of level info or higher.
# Don't log private authentication messages!
*.info;mail.none;authpriv.none;cron.none                /var/log/messages

# The authpriv file has restricted access.
authpriv.*                                              /var/log/secure

# Log all the mail messages in one place.
mail.*                                                  -/var/log/maillog


# Log cron stuff
cron.*                                                  /var/log/cron

# Everybody gets emergency messages
*.emerg                                                 :omusrmsg:*

# Save news errors of level crit and higher in a special file.
uucp,news.crit                                          /var/log/spooler

# Save boot messages also to boot.log
local7.*                                                /var/log/boot.log


# ### begin forwarding rule ###
# The statement between the begin ... end define a SINGLE forwarding
# rule. They belong together, do NOT split them. If you create multiple
# forwarding rules, duplicate the whole block!
# Remote Logging (we use TCP for reliable delivery)
#
# An on-disk queue is created for this action. If the remote host is
# down, messages are spooled to disk and sent when it is up again.
#$ActionQueueFileName fwdRule1 # unique name prefix for spool files
#$ActionQueueMaxDiskSpace 1g   # 1gb space limit (use as much as possible)
#$ActionQueueSaveOnShutdown on # save messages to disk on shutdown
#$ActionQueueType LinkedList   # run asynchronously
#$ActionResumeRetryCount -1    # infinite retries if host is down
# remote host is: name/ip:port, e.g. 192.168.0.1:514, port optional
#*.* @@remote-host:514
# ### end of the forwarding rule ###

### 10-15 commented out these rule at bottom
#$ModLoad imudp
#$UDPServerRun 514

# provides TCP syslog reception
#$ModLoad imtcp
#$InputTCPServerRun 10514

